import re, datetime

def parse( filename ):
    line_re = re.compile( "(\w{3} \w{3}\s+\d+ [\d:]+ \d+)"
            "\s+sensor (\d+) [\dA-F]+:\s+-?[\d\.]+C\s+-?([\d\.]+)F"
            "\s+sensor (\d+) [\dA-F]+:\s+-?[\d\.]+C\s+-?([\d\.]+)F" )

    fd = open( filename, "r" )
    data = []

    for line in fd.readlines():
        match = line_re.match( line )
        if not match:
            continue
        temp = range( 2 )
        sensor = range( 2 )
        date, sensor[ 0 ], temp[ 0 ], sensor[ 1 ], temp[ 1 ] = match.groups()
        # suck
        date = datetime.datetime.strptime( date, "%a %b %d %H:%M:%S %Y" )
        temp = map( float, temp )

        data.append( [ date ] + temp )

    fd.close()
    return data

def smooth( data, interval ):
    """'interval' in seconds"""

    interval = datetime.timedelta( 0, interval )
    half_interval = interval / 2

    a = 0
    new_data = []
    sum = [ 0 for x in data[ 0 ][ 1: ] ]
    for b in range( len( data )):
        for i in range( len( sum )):
            sum[ i ] += data[ b ][ i + 1 ]
        while data[ b ][ 0 ] - data[ a ][ 0 ] > interval:
            for i in range( len( sum )):
                sum[ i ] -= data[ a ][ i + 1 ]
            a += 1
        avg = [ s / ( b+1 - a) for s in sum ]
        new_data.append( [ data[ b ][ 0 ] - half_interval ] + avg )

#        def float_string( flt ):
#            return "%.2f" % flt
#        print data[ b ][ 0 ], map( float_string, data[ b ][ 1: ] ), \
#                map( float_string, sum )

    return new_data
